unit example_info;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, tedia_DAQ01h, Registry, Math, ComCtrls,
  AppEvnts;

type
  ADWord=array of DWord;
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    procedure FormCreate(Sender: TObject);
  private
  public
    count_registry_card:DWord;
    cesta_k_tedia_dll:string;
    aktivni_sloupec:DWord;
    call_buffer:PDWord;
    call_size_of_buffer:DWord;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  result_:DWord;
  i,j,k:integer;

  Pstr:array[0..255] of char;
  Imemo:TMemo;
  Itab_sheet:TTabSheet;

  //Priznak jestli je parametr znam
  known_parametrs:array[0..10000] of boolean;

  numerical_result:double;
  alphanumeric_result:array[0..255] of char;
  name_parametr:array[0..255] of char;
  type_of_result:DWord;
  type_of_result_base:DWord;
  retezec:string;
  Fset:boolean;
  nothing:DWORD;
  
  Ccards:DWORD;
begin
  Td_Get_Number_Of_Types(@Ccards);

  aktivni_sloupec:=0;

  //Zjisti se pocet typu
  for i := 0 to Ccards-1 do
  begin
    Itab_sheet:=TTabSheet.Create(Self);
    Itab_sheet.PageControl := PageControl1;
    PageControl1.Pages[i].TabVisible := true;

    Td_Get_DeviceType(@Pstr[0],i);
    Itab_sheet.Caption :=String(Pstr);

    Imemo:=TMemo.Create(Itab_sheet);
    Imemo.Parent := Itab_sheet;
    Imemo.Align:=alClient;
    Imemo.Visible:=true;
    Imemo.ScrollBars:=ssVertical;


    Imemo.Lines.Add('Pro tento typ zazen jsou definovny parametry:');
    Imemo.Lines.Add('--------------------------------------------------------------------------------------------------');
    Imemo.Lines.Add('jmeno parametru = numerick formt [znakov formt]');
    Imemo.Lines.Add('');
    for j:=0 to 100-1 do
    begin
      Fset:=false;
      //Hledaji se parametry, nejprve se ulozi informace o tom ktere jsou pro zarizeni definovany
      numerical_result:=0;
      Td_Get_Info_DeviceType(@Pstr[0],(j*100)+1,@numerical_result,@alphanumeric_result[0],@type_of_result);

      if(type_of_result=0) then
        known_parametrs[(j*100)+1]:=false
      else
      begin
        known_parametrs[(j*100)+1]:=true;
        Fset:=true;
      end;

      //1. parametr stovky je vzdy klicovy a urcuje jestli je ve stovce nejaky platny parametr
      if(Fset) then
      begin
        for k:=2 to 100 do
        begin
          result_:=Td_Get_Info_DeviceType(@Pstr[0],(j*100)+k,@numerical_result,@alphanumeric_result[0],@type_of_result);

          if(type_of_result=0) then
            known_parametrs[(j*100)+k]:=false
          else
            known_parametrs[(j*100)+k]:=true;
        end;
      end
      else
      begin
        for k:=2 to 100 do
        begin
          known_parametrs[(j*100)+k]:=false;
        end;
      end;
    end;

    for j:=0 to 10000-1 do
    begin
      if(known_parametrs[j]) then
      begin

        //Zjisti se hodnota parametru
        result_:=Td_Get_Info_DeviceType(@Pstr[0],j,@numerical_result,@alphanumeric_result[0],@type_of_result_base);
        if(result_=0)then
        begin
          //Zjisti se nazev parametru
          result_:=Td_Get_Info_DeviceType(@Pstr[0],j+10000,@nothing,@name_parametr[0],@type_of_result);
          if(result_=0) then
          begin
            retezec:=String(name_parametr)+'=';

            if((type_of_result_base and 1)=1) then
            begin
              retezec:=retezec+' '+FloatToStr(numerical_result);
            end;

            if((type_of_result_base and 2)=2) then
            begin
              retezec:=retezec+' ['+String(alphanumeric_result)+']';
            end;

            Imemo.Lines.Add(retezec);
          end;
        end;
      end;
    end;

    Imemo.Lines.Add('');
    Imemo.Lines.Add('Pro tento typ zazen NEjsou definovny parametry:');
    Imemo.Lines.Add('--------------------------------------------------------------------------------------------------');

    Fset:=true;
    for j:=0 to 100-1 do
    begin
      for k:=1 to 100 do
      begin
        if(k=1) then Fset:=true;

        if(Fset) then
        begin

          if(not(known_parametrs[j*100+k])) then
          begin

            result_:=Td_Get_Info_DeviceType(@Pstr[0],(j*100+k)+10000,@numerical_result,@name_parametr[0],@type_of_result);
            if(type_of_result<>0) then
            begin
              Imemo.Lines.Add(String(name_parametr));
            end
            else
              Fset:=false;

          end;

        end;
      end;
    end;
  end;

end;

end.
